/* armaimp.prc: calculates impulse response function for arma model. */

/* Adopted from code contained in the library TSAGAUSS, R. Schlittgen and T. Noack */
/*
Inputs: a, px1 vector of AR coefficients
	b, qx1 vector of MA coefficients
	m, horizon for impulse responses

Output: c, impulse responses

Format: c = armaimp(a,b,m);

*/

PROC (1)= armaimp(a,b,m);

   LOCAL a1,b1,c,i,p;
   p=ROWS(a);
   c=ZEROS(p+m,1);  c[p]=1;
   IF m==0; GOTO fin; ENDIF;
   a1=REV(a)';  b1=b|ZEROS(m,1);
   i=1;
   DO WHILE i<=m;
     c[i+p]=a1*c[i:(p+i-1)] - b1[i];
     i=i+1;
   ENDO;
 fin:
 RETP(TRIMR(c,p,0));
ENDP;

